
using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Wo_WorkCopy
    /// </summary>
    public partial class T_Wo_WorkCopy
    {
        public T_Wo_WorkCopy()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Wo_WorkCopy");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_WorkCopy");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Wo_WorkCopy model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_WorkCopy(");
            strSql.Append("F_WorkOrderID,F_State,F_CreateBy,F_CreateOn,F_SendCopyUser,F_SendCopyOn,F_Content,F_SendCopyDepts,F_Flag,F_Remark)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderID,@F_State,@F_CreateBy,@F_CreateOn,@F_SendCopyUser,@F_SendCopyOn,@F_Content,@F_SendCopyDepts,@F_Flag,@F_Remark)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderID", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_SendCopyUser", SqlDbType.NText),
                    new SqlParameter("@F_SendCopyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_SendCopyDepts", SqlDbType.Int,4),
                    new SqlParameter("@F_Flag", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NText)};
            parameters[0].Value = model.F_WorkOrderID;
            parameters[1].Value = model.F_State;
            parameters[2].Value = model.F_CreateBy;
            parameters[3].Value = model.F_CreateOn;
            parameters[4].Value = model.F_SendCopyUser;
            parameters[5].Value = model.F_SendCopyOn;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_SendCopyDepts;
            parameters[8].Value = model.F_Flag;
            parameters[9].Value = model.F_Remark;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Wo_WorkCopy model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_WorkCopy set ");
            strSql.Append("F_WorkOrderID=@F_WorkOrderID,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_SendCopyUser=@F_SendCopyUser,");
            strSql.Append("F_SendCopyOn=@F_SendCopyOn,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_SendCopyDepts=@F_SendCopyDepts,");
            strSql.Append("F_Flag=@F_Flag,");
            strSql.Append("F_Remark=@F_Remark");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderID", SqlDbType.Int,4),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_SendCopyUser", SqlDbType.NText),
                    new SqlParameter("@F_SendCopyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_SendCopyDepts", SqlDbType.Int,4),
                    new SqlParameter("@F_Flag", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderID;
            parameters[1].Value = model.F_State;
            parameters[2].Value = model.F_CreateBy;
            parameters[3].Value = model.F_CreateOn;
            parameters[4].Value = model.F_SendCopyUser;
            parameters[5].Value = model.F_SendCopyOn;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_SendCopyDepts;
            parameters[8].Value = model.F_Flag;
            parameters[9].Value = model.F_Remark;
            parameters[10].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkCopy ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkCopy ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_WorkCopy GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_WorkOrderID,F_State,F_CreateBy,F_CreateOn,F_SendCopyUser,F_SendCopyOn,F_Content,F_SendCopyDepts,F_Flag,F_Remark from T_Wo_WorkCopy ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Wo_WorkCopy model = new CallCenterApi.Model.T_Wo_WorkCopy();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_WorkCopy DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Wo_WorkCopy model = new CallCenterApi.Model.T_Wo_WorkCopy();
            if (row != null)
                {
                    if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                    {
                        model.F_ID = int.Parse(row["F_ID"].ToString());
                    }
                    if (row["F_WorkOrderID"] != null && row["F_WorkOrderID"].ToString() != "")
                    {
                        model.F_WorkOrderID = int.Parse(row["F_WorkOrderID"].ToString());
                    }
                    if (row["F_State"] != null && row["F_State"].ToString() != "")
                    {
                        model.F_State = int.Parse(row["F_State"].ToString());
                    }
                    if (row["F_CreateBy"] != null)
                    {
                        model.F_CreateBy = row["F_CreateBy"].ToString();
                    }
                    if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                    {
                        model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                    }
                    if (row["F_SendCopyUser"] != null)
                    {
                        model.F_SendCopyUser = row["F_SendCopyUser"].ToString();
                    }
                    if (row["F_SendCopyOn"] != null && row["F_SendCopyOn"].ToString() != "")
                    {
                        model.F_SendCopyOn = DateTime.Parse(row["F_SendCopyOn"].ToString());
                    }
                    if (row["F_Content"] != null)
                    {
                        model.F_Content = row["F_Content"].ToString();
                    }
                    if (row["F_SendCopyDepts"] != null && row["F_SendCopyDepts"].ToString() != "")
                    {
                        model.F_SendCopyDepts = int.Parse(row["F_SendCopyDepts"].ToString());
                    }
                    if (row["F_Flag"] != null && row["F_Flag"].ToString() != "")
                    {
                        model.F_Flag = int.Parse(row["F_Flag"].ToString());
                    }
                    if (row["F_Remark"] != null)
                    {
                        model.F_Remark = row["F_Remark"].ToString();
                    }
                }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Wo_WorkCopy ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Wo_WorkCopy ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_WorkCopy ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_WorkCopy T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

